package testPackage;

import static org.junit.Assert.*;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.junit.Before;
import org.junit.Test;

import windowsPackage.Customer;
import windowsPackage.Database;

public class CustomerTest {
	private Customer customer = new Customer();
	private Database db;
	
	
	@Before
	public void setUp() throws Exception {
		try {
			db = new Database();
		}
		catch(SQLException e) {
			System.out.println(e);
		}
	}

	@Test
	public void testCustomerMainFrame() {
		fail("Not yet implemented");
	}

	@Test
	public void testCustomer() {
		fail("Not yet implemented");
	}

	@Test
	public void testCustomerIntStringStringStringStringStringStringStringString() {
		fail("Not yet implemented");
	}

	@Test
	public void testVerifyInput() {
		customer.setFirstName("Unit");
		customer.setLastName("Test");
		customer.setCPR("1234123412");
		customer.setAdress1("Street 1");
		customer.setAdress2("1111 City");
		customer.setPhoneNumber("22112211");
		customer.setEmail("mail@domain.com");
		customer.setPassportNumber("1234512345");
		assertEquals("VerifyInputTest", "true", customer.verifyInput());
		customer.setPassportNumber("");
		assertEquals("VerifyInputTest", "Alle felter skal udfyldes", customer.verifyInput());
		customer.setPassportNumber("1234512345");
		customer.setCPR("ThisIsntNumbers");
		assertEquals("VerifyInputTest", "Felterne med CPR, telefonnummer og pasnummer m kun indeholde tal",
				customer.verifyInput());
		customer.setCPR("1234512345");
		customer.setFirstName("This name has way more than 100 charachters This name has way more than" +
				" 100 charachters This name has way more than 100 charachters");
		assertEquals("VerifyInputTest", "Felterne 'Fornavn', 'Efternavn', 'Adresse', 'By og postnummer' " +
				"og 'Email' m ikke vre lngere end 100 karakterer ", customer.verifyInput());
	}

	@Test
	public void testGetInput() {
		fail("Not yet implemented");
	}

	@Test
	public void testCreateCustomer() {
		//Fjern MainFrame.removeContent(); fra createCustomer() for at undgaa nullPointerException
		String cmd = "SELECT COUNT(*) FROM `Customers`";
		int i = 0;
		try {
			ResultSet rs = db.execute(cmd);
			while(rs.next()) {
				i = rs.getInt(1);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		//Alle felter skal udfyldes
		customer.setFirstName("");
		customer.setLastName("Test");
		customer.setCPR("1234123412");
		customer.setAdress1("Street 1");
		customer.setAdress2("1111 City");
		customer.setPhoneNumber("22112211");
		customer.setEmail("mail@domain.com");
		customer.setPassportNumber("1234512345");
		customer.createCustomer();
		assertEquals("VerifyInputTest", i, getCustomerCount());
		//Input felter m ikke indeholde mere end 100 tegn.
		customer.setFirstName("This name has way more than 100 characters This name has way more than" +
				" 100 characters This name has way more than 100 characters This name has way more than 100 characters");
		assertEquals("VerifyInputTest", i, getCustomerCount());
		//CPR SKAL vaere tal
		customer.setFirstName("Unit");
		customer.setCPR("ThisIsntNumbers");
		assertEquals("VerifyInputTest", i, getCustomerCount());
		
		//CPR SKAL vaere 10 tegn
		customer.setCPR("12341234");
		assertEquals("VerifyInputTest", i, getCustomerCount());
		
		customer.setCPR("1234123412");
		customer.createCustomer();
		assertEquals("VerifyInputTest", i+1, getCustomerCount());
	}
	
	private int getCustomerCount() {
		String cmd = "SELECT COUNT(*) FROM `Customers`";
		int i = 0;
		try {
			ResultSet rs = db.execute(cmd);
			while(rs.next()) {
				i = rs.getInt(1);
			}
		} catch (SQLException e) {
			e.printStackTrace();
		}
		return i;
		
	}
}
