package testPackage;

import static org.junit.Assert.*;

import java.sql.ResultSet;
import java.sql.SQLException;

import javax.swing.JOptionPane;

import mainPackage.MainFrame;

import org.junit.Before;
import org.junit.Test;

import windowsPackage.Database;
import windowsPackage.Travel;

public class TravelTest {
	private MainFrame mf = new MainFrame();
	private Travel travel;
	
	@Test
	public void testTravelMainFrame() {
		fail("Not yet implemented");
	}
	
	@Before
	public void setUp() throws Exception {
		try {
			travel = new Travel(mf);
		}
		catch(SQLException e) {
			System.out.println(e);
		}
	}

	@Test
	public void testTravelIntegerIntegerStringStringStringString() {
		fail("Not yet implemented");
	}

	@Test
	public void testVerifyInput() {
		travel.setFlightID("1");
		travel.setFrom("Billund");
		travel.setTo("Kbenhavn");
		travel.setDepYear("2012");
		travel.setDepMonth("12");
		travel.setDepDay("31");
		travel.setDepHour("12");
		travel.setDepMin("00");
		travel.setArrYear("2012");
		travel.setArrMonth("12");
		travel.setArrDay("31");
		travel.setArrHour("14");
		travel.setArrMin("000");
		assertEquals("CreateTravel", "Forkert dato format. Datoen skal skrives i formatet yyyy-mm-dd hh:mm", travel.verifyInput());
		travel.setArrMin("00");
		travel.setTo("This City has way more than 100 characters This City has way more than 100 characters This City has way more than 100 characters This City has way more than 100 characters This City has way more than 100 characters This City has way more than 100 characters");
		assertEquals("HugeAmountInputTest", "Felterne 'Fra' og 'Til' m ikke vre lngere end 100 karakterer", travel.verifyInput());
		travel.setTo("Kbenhavn");
		assertEquals("VerifyInputTest", "true", travel.verifyInput());
		
	}

	@Test
	public void testCreateTravel() {
		try {
			Database db = new Database();
			String cmd = "SELECT COUNT(*) FROM `Seats`";
			ResultSet rs = db.execute(cmd);
			int i = 0;
			while(rs.next()) {
				i = rs.getInt(1);
			}
			travel.setFlightID("1");
			travel.setFrom("Billund");
			travel.setTo("Kbenhavn");
			travel.setDepYear("2012");
			travel.setDepMonth("12");
			travel.setDepDay("31");
			travel.setDepHour("12");
			travel.setDepMin("00");
			travel.setArrYear("2012");
			travel.setArrMonth("12");
			travel.setArrDay("31");
			travel.setArrHour("14");
			travel.setArrMin("00");
			travel.insertTravel();
			assertEquals("CreateTravelTest", i+90, countCustomer());
		}
		catch(SQLException e) {
			System.out.println("Der skete en fejl. Fejlkode: " + e);
		}
	}
	
	public int countCustomer() {
		try {
		Database db = new Database();
		String cmd = "SELECT COUNT(*) FROM `Seats`";
		ResultSet rs = db.execute(cmd);
		int i = 0;
			while(rs.next()) {
				i = rs.getInt(1);
			}
		return i;
		}
		catch(SQLException e) {
			System.out.println("Der skete en fejl :( Fejlkode: " + e);
		}
		return 0;
	}

}
